clc
clear  all

%Antar 900K i varmerret
T=input('Tast inn temperaturen i varmerret[K]');


%Konstanter fra PotassiumData, eget script med data fra Faghris Heat Pipe S&T
my=PotassiumData(T,6);
rho=PotassiumData(T,4);
Hfg=PotassiumData(T,3);
p_sat=PotassiumData(T,2);
sigma=PotassiumData(T,10);

%Andre Konstanter 
K=3.14e-12;
reff=11.9e-6;
g=9.81;


% %Lengder og vektorer
% hoyde=0.30;%Bredde og hyde p veken
% bredde=0.30;%Bredde og hyde p veken
% tykkelse=0.002;
makshoyde=2*sigma/reff/rho/g;
logisktest=0;
while logisktest==0
hoyde=input('Tast inn hyden p veken[m]');
if hoyde<makshoyde
    logisktest=1;
else
    disp('Denne hyden er strre enn maks lftehyde ved null strmning, tast inn en mindre hyde')
end
end
    
bredde=input('Tast inn bredden p veken[m]');
tykkelse=input('Tast inn tykkelsen p veken[m]');
rho=rho*tykkelse;% korrigerer massetetthet per volum til massetetthet per areal, dybde:2mm
beta=my/K/rho;

% N=80;                                                             %Antall celler i en retning. Kan (og br) endres hvis man fr geometrier  
N=input('Velg antall celler(under ~100)');

dx=(bredde/N);                                                      %som avviker mye fra rektangulr form.
dy=(hoyde/N);

xv=dx/2:dx:(bredde-dx/2);
yv=dy/2:dy:(hoyde-dy/2);
%Definerer hydrostatisk trykkfelt(benyttes frst nr man sjekker
%resulterende trykkfelt
p_hydstat=zeros(N,N);
for i=1:N
p_hydstat(i,:)=rho/tykkelse*g*(hoyde-yv(:));
end

a=dx/dy;                    %Konstanter benyttet i utregningen av trykkfeltet
b=1/a;                      %Konstanter benyttet i utregningen av trykkfeltet

%lsningsmatriser;
p=zeros(N,N);

%Sinks and sources
q_normal=13.13; %kW/m2                         %Startverdi for whilelkken og utgangspunkt for hotspot.

hotspotvalg=input('Velg vertikal plassering av hotspot.1- oppe, 2-midten, 3-nede, alt annet gir ingen hotspot');
hotspotvalg2=input('Velg horisontal plassering av hotspot.1- siden, 2-midten, alt annet gir ingen hotspot');



Trykkratio=0.5;
while Trykkratio>1.0001 || Trykkratio<0.9999      %While lkke for  finne maksimal kapasitet til veken. Denne kjrer til kapasiteten er maksimal.

q_burn=300;%20*q_normal;%kW/m2
m_normal=q_normal/Hfg;%kg/sm2
m_burn=q_burn/Hfg;%kg/sm2
alpha=zeros(N,N);
alpha(1:N,1:N)=-m_normal;


if hotspotvalg==1 && hotspotvalg2==1
%Gjennombrenning oppe til venstre
alpha(floor(N/4-N/20):(floor(N/4+N/20)),(floor(3*N/4-N/20)):(floor(3*N/4+N/20)))=-m_burn;
hotspotposisjon=1;
elseif hotspotvalg==2 && hotspotvalg2==1
% %Gjennombrenning midten til venstre
alpha(floor(N/4-N/20):(floor(N/4+N/20)),(floor(N/2-N/20)):(floor(N/2+N/20)))=-m_burn;
hotspotposisjon=3;
elseif hotspotvalg==3 && hotspotvalg2==1
%Gjennombrenning nede til venstre
alpha(floor(N/4-N/20):(floor(N/4+N/20)),(floor(N/4-N/20)):(floor(N/4+N/20)))=-m_burn;
hotspotposisjon=5;

elseif hotspotvalg==1 && hotspotvalg2==2
%Gjennombrenning oppe og midten
alpha((floor(N/2-N/20)):(floor(N/2+N/20)),(floor(3*N/4-N/20)):(floor(3*N/4+N/20)))=-m_burn;
hotspotposisjon=2;
elseif hotspotvalg==2 && hotspotvalg2==2
%Gjennombrenning midten og midten
alpha((floor(N/2-N/20)):(floor(N/2+N/20)),(floor(N/2-N/20)):(floor(N/2+N/20)))=-m_burn;
hotspotposisjon=4;
elseif hotspotvalg==3 && hotspotvalg2==2
%Gjennombrenning nede og midten
alpha((floor(N/2-N/20)):(floor(N/2+N/20)),(floor(N/4-N/20)):(floor(N/4+N/20)))=-m_burn;
hotspotposisjon=6;
end

%Boundary Conditions

pBC=p_sat-(rho/tykkelse*g*hoyde);          %Grensebetingelse ved nedre flate.

        A=zeros(N^2);
        B=zeros(N^2,1);
        for I=1:N^2                         %Oppsett av problemet. Setter opp en pentadiagonal matrise der hver rekke i matrisa tilsvarer ligningen til en celle
            
            EnDtilToD=I/N;          %Konvertering fra/til 2D koordinatsystem og 1D koordinatsystem
            j=ceil(EnDtilToD);
            i=I-(j-1)*N;

            if i==1 && (j<N && j>1)     %W
                 A(I,I)=-(2*a+b);
                 A(I,I+1)=b;
                 A(I,I+N)=a;
                 A(I,I-N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j);
            elseif i==N && (j<N && j>1) %E
                 A(I,I)=-(2*a+b);
                 A(I,I-1)=b;
                 A(I,I+N)=a;
                 A(I,I-N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j);
            elseif j==N && (i<N && i>1) %N
                 A(I,I)=-(a+2*b);
                 A(I,I-1)=b;
                 A(I,I+1)=b;
                 A(I,I-N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j);%+rho*g*dx;
            elseif j==1 && (i<N && i>1) %S
                 A(I,I)=-(3*a+2*b);
                 A(I,I-1)=b;
                 A(I,I+1)=b;
                 A(I,I+N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j)-2*a*pBC;           
            elseif i==1 && j==1     %SW
                 A(I,I)=-(3*a+b);
                 A(I,I+1)=b;
                 A(I,I+N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j)-2*a*pBC;
            elseif i==1 && j==N     %NW
                 A(I,I)=-(a+b);
                 A(I,I+1)=b;
                 A(I,I-N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j);%+rho*g*dx;
            elseif i==N && j==N     %NE
                 A(I,I)=-(a+b);
                 A(I,I-1)=b;
                 A(I,I-N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j);%+rho*g*dx;
            elseif i==N && j==1     %SE
                 A(I,I)=-(3*a+b);
                 A(I,I-1)=b;
                 A(I,I+N)=a;
                 B(I)=-dx*dy*beta*alpha(i,j)-2*a*pBC;
            else               
            
            %Diagonal
            A(I,I)=-(2*a+2*b);
            %Temp til venstre
            A(I,I-1)=b;
            %Temp til hyre
            A(I,I+1)=b;
            %Temp over
            A(I,I+N)=a;
            %Temp under
            A(I,I-N)=a;
            %b vektor
            B(I)=-dx*dy*beta*alpha(i,j);
            end  
                
        end
        
        A=sparse(A);                        %Lsning av problemet
        P= A\B;
        
        for I=1:N^2                 %Konvertering fra/til 2D koordinatsystem og 1D koordinatsystem
            EnDtilToD=I/N;          %Konvertering fra/til 2D koordinatsystem og 1D koordinatsystem
            j=ceil(EnDtilToD);
            i=I-(j-1)*N;
            p(i,j)=P(I);            %omgjr lsningsvektoren til en lsningsmatrise
        end
        
        u=zeros(N-2,N-2);
        v=zeros(N-2,N-2);
        
        for i=2:N-1                 %Hastightetsvektorer, Darcy
            for j=2:N-1
                u(i-1,j-1)=-K/my*((p(i+1,j)-p(i-1,j))/dx/2);
                v(i-1,j-1)=-K/my*(((p(i,j+1)-p(i,j-1))/dy/2));%+rho*g);
            end
        end
        p=p+p_hydstat; %Legger p det hydrostatiske trykkfeltet fr trykksjekken (Trykkratio) gjres)
        p=p';                       %Triksing med svarmatriser for at plottingen gir bedre gravitasjonsvektor langs y-aksen.
        alpha=alpha';
        u=u';
        v=v';
    q_endelig=q_normal
    pmin=p_sat-2*sigma/reff;
    Trykkratio=min(min(p))/pmin;
if Trykkratio<1
   q_normal=q_normal*0.9999;
else
   q_normal=q_normal*1.0001;
end
end
        
% subplot(1,3,1),
[c, h] = contour(xv,yv,p); 
clabel(c, h); 
ylabel('Hoydeakse[m]')
xlabel('Breddeakse[m]')
title(['Trykkfordeling[Pa] - Hyfluksposisjon ', num2str(hotspotposisjon),])
grid on
% subplot(1,3,2),
% [c, h] = contour(xv,yv,alpha);
% clabel(c, h); 
% ylabel('Hoydeakse[m]')
% xlabel('Breddeakse[m]')
% title(['Posisjon av hotspot, total massesluk: ', num2str(sum(sum(alpha(:,:)*dx*dy))),' kg/s'])
% legend(['Gjennomsnittlig varmefluks:',num2str(Hfg/bredde/hoyde*sum(sum(alpha)*dx*dy)),' kW/m2'])

% subplot(1,3,3),
% quiver(u,v)
% ylabel('Breddeakse[m]')
% xlabel('Hoydeakse[m]')
% title('Hastighetsvektorer')

if p_sat > 2*sigma/reff
    pmin=p_sat-2*sigma/reff;
    Trykkratio=min(min(p))/pmin;
    text1=['Ok damptrykk, trykkratio er: ', num2str(Trykkratio),', '];
else
    Trykkdifferanse=min(min(p));
    text1='Lavt damptrykk, ';
end



M_maks=sum(sum(abs(alpha*dx*dy)));
q_maks=M_maks*Hfg/bredde/hoyde;
text3=['Maksimal gjennomsnittlig varmefluks er: ', num2str(q_maks),'kW/m2, '];
%Biten under gir maksimalhastigheten. Siden standard utrgning over bare
%beregner interirceller, m dette gjres separat.
Maksimalhastighet1=abs(q_maks*hoyde/Hfg/rho);
Maksimalhastighet2=max(max(abs(u)));
Maksimalhastighet3=max(max(abs(v)));
Maksimalhastighet=max([Maksimalhastighet1,Maksimalhastighet2,Maksimalhastighet3]);
ReK=Maksimalhastighet*K^0.5*rho/my;
if ReK<1
    text2='Innenfor Darcy domene, ';
else
    text2='Utenfor Darcy domene, ';
end
%Sjekker overenstemmelse med kapillrgrensen.
m_maks=2*K*rho*bredde/hoyde/my*(2*sigma/reff-rho/tykkelse*g*hoyde);
Ratio=M_maks/m_maks;

%clc
disp([text1,text2,text3])